//fragment shader
//by K

varying vec4 position;
varying vec3 normal;

const float scale = 3.0;

const float min_blue = 0.5;

void main()
{
	vec3 light_dir = normalize(vec3(gl_LightSource[0].position));
	

	
	vec3 surface_normal = normalize(normal); //gl_NormalMatrix * normal;
	//float interference =((sin(position.x*scale)+cos(position.y*scale))*20.0);

	
	//surface_normal = vec3(surface_normal.x * (sin(position.x * scale)+cos(position.z * scale)),
	//		      surface_normal.y * (sin(position.z * scale)+cos(position.x * scale)),
	//		      surface_normal.z * (cos(position.x * scale)+sin(position.x * scale)));
				  
	surface_normal.x += (cos(position.x*scale)+ sin(position.z*scale)) * 0.02;
	surface_normal.y += (cos(position.y*scale)+ sin(position.z*scale)) * 0.02;
	surface_normal.z += (sin(position.x*scale)+ cos(position.z*scale)) * 0.02;
	
	//surface_normal = normalize(surface_normal);
				  
				  
	float difuse = max(dot(light_dir,surface_normal),0.0); 
	
	
	vec3 color = vec3(0,0,0);
	
	if(difuse != 0.0)
	{
		vec3 HV  = vec3(gl_LightSource[0].halfVector.xyz) / gl_LightSource[0].halfVector.w;
		float DotHV = max(dot(HV,surface_normal),0.0);
	
		float specular = pow(DotHV,50.0);

		color += vec3(0.7,0.7,9.0) * difuse;
		color += vec3(1.0,1.0,0.8) * specular;
	}
	
	gl_FragColor = vec4(color,1.0); 
}